EMOTELIST_VERSION = GetAddOnMetadata("EmoteList", "Version");
---------------------------------------------------------------------------------
-- SAVED
---------------------------------------------------------------------------------
EmoteListOpt = {
	["EmoteListVersion"] = EMOTELIST_VERSION;
	["EmoteListFirstrun"] = true;
	["EmoteListStartFrame"] = 8;
	["Zwischenspeicher"] = {"3", 20, "U"};
	["EmoteListUpdate"] = true;
};
EmoteListDB = {};
---------------------------------------------------------------------------------
-- OnLoad
---------------------------------------------------------------------------------
function EmoteList_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("MODIFIER_STATE_CHANGED");
	this:RegisterEvent("ADDON_LOADED");	
	--EmoteList_Init();
end

---------------------------------------------------------------------------------
-- OnEvent
---------------------------------------------------------------------------------
function EmoteList_OnEvent()
	if event == "VARIABLES_LOADED" then 
		EmoteList_Init(); 
	end
end

function EmoteList_Init()
	if EmoteListOpt["EmoteListFirstrun"] == true then
		for i=1, 34 do
			EmoteListDB["FavEmote"..i] = {"3", 20, "U"}
			EmoteListDB["CustomEmote"..i] = {"", "", "", "", ""}
		end
		EmoteListOpt["EmoteListFirstrun"] = false;
	end
	if EmoteListOpt["EmoteListVersion"] == "0.2" then
		for i=1, 34 do
			EmoteListDB["CustomEmote"..i] = {"", "", "", "", ""}
		end
		EmoteListOpt["EmoteListVersion"] = "0.3";
	end
	if (not EmoteListOpt["EmoteListOptionenId"]) then EmoteListOpt["EmoteListOptionenId"] = 1 end;
	if (not EmoteListOpt["EmoteListUpdate"]) then EmoteListOpt["EmoteListUpdate"] = false end;
	if (not EmoteListOpt["EmoteListMenuTooltip1"]) then EmoteListOpt["EmoteListMenuTooltip1"] = true end;
	if (not EmoteListOpt["EmoteListMenuTooltip1"]) then EmoteListOpt["EmoteListMenuTooltip2"] = true end;
	if (not EmoteListOpt["EmoteListMenuTooltip1"]) then EmoteListOpt["EmoteListMenuTooltip3"] = true end;
	if (not EmoteListOpt["EmoteListMenuTooltip1"]) then EmoteListOpt["EmoteListMenuTooltip4"] = true end;
	if (not EmoteListOpt["EmoteListMenuTooltip1"]) then EmoteListOpt["EmoteListMenuTooltip5"] = true end;
	if (not EmoteListOpt["CustomEmoteNr"]) then EmoteListOpt["CustomEmoteNr"] = 1 end;
	if (not EmoteListOpt["EmoteListStartFrame"]) then EmoteListOpt["EmoteListStartFrame"] = 8 end;
	if (EmoteListOpt["EmoteListVersion"] ~= EMOTELIST_VERSION) and (not EmoteListOpt["EmoteListVersion"] == 0.2) then
		EmoteListOpt["EmoteListVersion"] = EMOTELIST_VERSION;
	end
end

---------------------------------------------------------------------------------
-- Fav Zwischenspeicher
---------------------------------------------------------------------------------
function EmoteListFavSpeichern(tabelle, id)
	EmoteListOpt["Zwischenspeicher"] = {tabelle, id, "U"};
	EmoteListMainFavSetzen:Show();
end

---------------------------------------------------------------------------------
-- Fav Setzen
---------------------------------------------------------------------------------
function EmoteListFavErstellen_OnClick()
	local id = this:GetID();
	local emoteid = EmoteListOpt["Zwischenspeicher"][2];
	local tabelle = EmoteListOpt["Zwischenspeicher"][1];
	
	EmoteListDB["FavEmote"..id] = {tabelle, emoteid, "U"};
	EmoteListMainFavSetzen:Hide();
	EmoteListOpt["Zwischenspeicher"] = {"3", 20, "U"};
end

---------------------------------------------------------------------------------
-- General Tooltips erstellen
---------------------------------------------------------------------------------
function EmoteList_ErstelleTooltip(slash, ohnetarget, mittarget, animation)
	if EmoteListOpt["EmoteListMenuTooltip1"] == true then
			GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
		if EmoteListOpt["EmoteListMenuTooltip2"] == true then
			GameTooltip:SetText(slash);
		end
		if EmoteListOpt["EmoteListMenuTooltip3"] == true then
    		GameTooltip:AddLine(ohnetarget, 1, 0, 0);
		end
		if EmoteListOpt["EmoteListMenuTooltip4"] == true then
    		GameTooltip:AddLine(mittarget, 0, 0, 1);
		end
		if EmoteListOpt["EmoteListMenuTooltip5"] == true then
    		GameTooltip:AddLine(" ");
    		GameTooltip:AddLine(animation, 0, 1, 0);
		end
    		GameTooltip:Show();			
	end
end

---------------------------------------------------------------------------------
-- Button text erstellen NORMAL
---------------------------------------------------------------------------------
function EmoteList_SetButtonText()
	if (not EmoteListNormal) then return end;
		local id = this:GetID();
		local buttontext = EmoteListNormal[id][2];

	if string.len(buttontext)==0 then
		this:Hide();
	else
		this:SetText(buttontext);	
	end
end

---------------------------------------------------------------------------------
-- Button text erstellen WOTLK
---------------------------------------------------------------------------------
function EmoteList_SetButtonTextWotlk()
	if (not EmoteListWotlk) then return end;
		local id = this:GetID();
		local buttontext = EmoteListWotlk[id][2];

	if string.len(buttontext)==0 then
		this:Hide();
	else
		this:SetText(buttontext);	
	end
end

---------------------------------------------------------------------------------
-- Button text erstellen FAV
---------------------------------------------------------------------------------
function EmoteList_SetButtonTextFav()
	local id = this:GetID();
	local tabelle = EmoteListDB["FavEmote"..id][1];
	local emoteid = EmoteListDB["FavEmote"..id][2];
	local titel = EmoteListDB["FavEmote"..id][3];
	if tabelle == "1" then
		EmoteList_FavLesenTabelleNormal(emoteid)
	end
	if tabelle == "2" then
		EmoteList_FavLesenTabelleWotlk(emoteid)
	end 
	if tabelle == "3" then
		this:SetText(" ");
	end 
	if tabelle == "4" then
		--EmoteListFavTitelErstellen(titel, id);
		--this:Hide();
	end 
end 

function EmoteList_SetButtonTextFavSetzen()
	local id = this:GetID();
	local tabelle = EmoteListDB["FavEmote"..id][1];
	local emoteid = EmoteListDB["FavEmote"..id][2];
	local titel = EmoteListDB["FavEmote"..id][3];
	if tabelle == "1" then
		EmoteList_FavLesenTabelleNormal(emoteid)
	end
	if tabelle == "2" then
		EmoteList_FavLesenTabelleWotlk(emoteid)
	end 
	if tabelle == "3" then
		this:SetText(">>> "..EMOTELIST_LEER.." <<<");
			end 
	if tabelle == "4" then
		this:SetText(">>> "..EMOTELIST_LEER.." <<<");
	end 

end

---------------------------------------------------------------------------------
-- Fav code
---------------------------------------------------------------------------------
function EmoteListFavTitelErstellen(titel, id)
	local tit = EmoteListDB["FavEmote"..id][3];
	 this:SetText(">>"..tit.."<<");
end

function EmoteList_FavLesenTabelleNormal(emoteid)
	local buttontext = EmoteListNormal[emoteid][2];
	if string.len(buttontext)==0 then
		this:Hide();
	else
		this:SetText(buttontext);	
	end
end

function EmoteList_FavLesenTabelleWotlk(emoteid)
	local buttontext = EmoteListWotlk[emoteid][2];
	if string.len(buttontext)==0 then
		this:Hide();
	else
		this:SetText(buttontext);	
	end
end

------------------------------------------------------------
-- Tooltips Fav code
---------------------------------------------------------------------------------
function EmoteList_ShowTooltipFavNormal(id)
		local emoteid = EmoteListDB["FavEmote"..id][2];
		local slash = EmoteListNormal[emoteid][3];
		local ohnetarget = EmoteListNormal[emoteid][4];
		local mittarget = EmoteListNormal[emoteid][5];
		local animation = EmoteListNormal[emoteid][6];
	if string.len(ohnetarget)>0 then
		EmoteList_ErstelleTooltip(slash, ohnetarget, mittarget, animation);
	end	
end

function EmoteList_ShowTooltipFavWotlk(id)
		local emoteid = EmoteListDB["FavEmote"..id][2];
		local slash = EmoteListWotlk[emoteid][3];
		local ohnetarget = EmoteListWotlk[emoteid][4];
		local mittarget = EmoteListWotlk[emoteid][5];
		local animation = EmoteListWotlk[emoteid][6];
	if string.len(ohnetarget)>0 then
		EmoteList_ErstelleTooltip(slash, ohnetarget, mittarget, animation);
	end	
end

---------------------------------------------------------------------------------
-- General Tooltips Zeigen/beschriften FAV
---------------------------------------------------------------------------------
function EmoteList_ShowTooltipFav()
	local id = this:GetID();
	local tabelle = EmoteListDB["FavEmote"..id][1];
	if tabelle == "1" then
		EmoteList_ShowTooltipFavNormal(id)
	end
	if tabelle == "2" then
		EmoteList_ShowTooltipFavWotlk(id)
	end	
end

---------------------------------------------------------------------------------
-- General Tooltips Zeigen/beschriften NORMAL
---------------------------------------------------------------------------------
function EmoteList_ShowTooltip()
	if (not EmoteListNormal) then return end;
		local id = this:GetID();
		local slash = EmoteListNormal[id][3];
		local ohnetarget = EmoteListNormal[id][4];
		local mittarget = EmoteListNormal[id][5];
		local animation = EmoteListNormal[id][6];
		
	if string.len(ohnetarget)>0 then
		EmoteList_ErstelleTooltip(slash, ohnetarget, mittarget, animation);
	end
end

---------------------------------------------------------------------------------
-- General Tooltips Zeigen/beschriften WOTLK
---------------------------------------------------------------------------------
function EmoteList_ShowTooltipWotlk()
	if (not EmoteListWotlk) then return end;
		local id = this:GetID();
		local slash = EmoteListWotlk[id][3];
		local ohnetarget = EmoteListWotlk[id][4];
		local mittarget = EmoteListWotlk[id][5];
		local animation = EmoteListWotlk[id][6];
		
	if string.len(ohnetarget)>0 then
		EmoteList_ErstelleTooltip(slash, ohnetarget, mittarget, animation);
	end
end

---------------------------------------------------------------------------------
-- FavButtonOnClick
---------------------------------------------------------------------------------
function FavButton_OnClick()
	local id = this:GetID();
	local emoteid = EmoteListDB["FavEmote"..id][2];
	local tabelle = EmoteListDB["FavEmote"..id][1];
	local emotecode1 = EmoteListNormal[emoteid][1];
	local emotecode2 = EmoteListWotlk[emoteid][1];
	if ( IsAltKeyDown() ) then
		EmoteListDB["FavEmote"..id] = {"3", 20, "U"};
		EmoteList_SetButtonTextFav();
	else
		if tabelle == "1" then
			DoEmote(emotecode1);
		end
		if tabelle == "2" then
			DoEmote(emotecode2);
		end
	end
end


---------------------------------------------------------------------------------
-- Do Emotes NORMAL
---------------------------------------------------------------------------------
function EmoteListButtonDoEmote_OnClick()
	local id = this:GetID();
	local emotecode = EmoteListNormal[id][1];
	local tabelle = EmoteListNormal[id][7];
	
	--DoEmote(emotecode);
	
	if ( IsAltKeyDown() ) then
		EmoteListFavSpeichern(tabelle, id);
	else
		DoEmote(emotecode);
	end
end

---------------------------------------------------------------------------------
-- Do Emotes WOTLK
---------------------------------------------------------------------------------
function EmoteListButtonDoEmoteWotlk_OnClick()
	local id = this:GetID();
	local emotecode = EmoteListWotlk[id][1];
	local tabelle = EmoteListWotlk[id][7];
		
	--DoEmote(emotecode);
	
	if ( IsAltKeyDown() ) then
		EmoteListFavSpeichern(tabelle, id);
	else
		DoEmote(emotecode);
	end
end

-----------------------------------------------------------
---Zurck Buttons click
-----------------------------------------------------------
function EmoteListZuruckButton_OnClick()
	-- Zurck zu Seite eins
		if(EmoteListMainPageZwei:IsVisible()) then
			EmoteListMainPageZwei:Hide();
			EmoteListMainPageEins:Show();
		end
	-- Zurck zu Seite zwei
		if(EmoteListMainPageDrei:IsVisible()) then
			EmoteListMainPageDrei:Hide();
			EmoteListMainPageZwei:Show();
		end
	-- Zurck zu Seite drei
		if(EmoteListMainPageVier:IsVisible()) then
			EmoteListMainPageVier:Hide();
			EmoteListMainPageDrei:Show();
		end
	-- Zurck zu Seite eins wotlk
		if(EmoteListMainWOTLKZwei:IsVisible()) then
			EmoteListMainWOTLKZwei:Hide();
			EmoteListMainWOTLK:Show();
		end
	-- Zurck zu Seite zwei wotlk
		if(EmoteListMainWOTLKDrei:IsVisible()) then
			EmoteListMainWOTLKDrei:Hide();
			EmoteListMainWOTLKZwei:Show();
		end
end

-----------------------------------------------------------
---Vor Buttons click
-----------------------------------------------------------

function EmoteListVorButton1_OnClick()
-- Vor zu Seite zwei
	if(EmoteListMainPageEins:IsVisible()) then
		EmoteListMainPageEins:Hide();
		EmoteListMainPageZwei:Show();
	end
end

function EmoteListVorButton2_OnClick()
-- Vor zu Seite drei
	if(EmoteListMainPageZwei:IsVisible()) then
		EmoteListMainPageZwei:Hide();
		EmoteListMainPageDrei:Show();
	end
end
function EmoteListVorButton3_OnClick()
-- Vor zu Seite vier
	if(EmoteListMainPageDrei:IsVisible()) then
		EmoteListMainPageDrei:Hide();
		EmoteListMainPageVier:Show();
	end
end
function EmoteListVorButtonWotlk_OnClick()
-- Vor zu Seite zwei Wotlk
	if(EmoteListMainWOTLK:IsVisible()) then
		EmoteListMainWOTLK:Hide();
		EmoteListMainWOTLKZwei:Show();
	end
end
function EmoteListVorButtonWotlk2_OnClick()
-- Vor zu Seite zwei Wotlk
	if(EmoteListMainWOTLKZwei:IsVisible()) then
		EmoteListMainWOTLKZwei:Hide();
		EmoteListMainWOTLKDrei:Show();
	end
end

function EmoteListButton_OnClick()
	local checkid = EmoteListOpt["EmoteListStartFrame"];
	if ( IsAltKeyDown() ) then
		if EmoteListCustomMainFrame:Show() then
			EmoteListCustomMainFrame:Hide();
		else
			EmoteListCustomMainFrame:Show();
		end
	else
		if(EmoteListMainFrame:IsVisible()) then
			EmoteListMainFrame:Hide();
			EmoteListMainPageEins:Hide();
			EmoteListMainPageZwei:Hide();
			EmoteListMainPageDrei:Hide();
			EmoteListMainPageVier:Hide();
			EmoteListMainWOTLK:Hide();
			EmoteListMainWOTLKZwei:Hide();
			EmoteListMainWOTLKDrei:Hide();
			EmoteListMainFav:Hide();
			EmoteListMainCustomSetzen:Hide();
		else
			EmoteListMainFrame:Show();
			if checkid == 1 then
				EmoteListMainPageEins:Show();
			end
			if checkid == 2 then
				EmoteListMainPageZwei:Show();
			end
			if checkid == 3 then
				EmoteListMainPageDrei:Show();
			end
			if checkid == 4 then
				EmoteListMainPageVier:Show();
			end
			if checkid == 5 then
				EmoteListMainWOTLK:Show();
			end
			if checkid == 6 then
				EmoteListMainWOTLKZwei:Show();
			end
			if checkid == 7 then
				EmoteListMainWOTLKDrei:Show();
			end
			if checkid == 8 then
				EmoteListMainFav:Show();
			end
			if checkid == 9 then
				EmoteListMainCustomSetzen:Show();
			end
		end
	end
end

-----------------------------------------------------------
---Menu buttons
-----------------------------------------------------------
function EmoteListNormal_OnClick()
	EmoteListMainPageZwei:Hide();
	EmoteListMainPageDrei:Hide();
	EmoteListMainWOTLK:Hide();
	EmoteListMainWOTLKZwei:Hide();
	EmoteListMainWOTLKDrei:Hide();
	EmoteListMainFav:Hide();
	EmoteListMainPageEins:Show();
	EmoteListMainCustomSetzen:Hide();
end

function EmoteListWOTLK_OnClick()
	EmoteListMainPageZwei:Hide();
	EmoteListMainPageDrei:Hide();
	EmoteListMainPageVier:Hide();
	EmoteListMainWOTLK:Show();
	EmoteListMainWOTLKZwei:Hide();
	EmoteListMainWOTLKDrei:Hide();
	EmoteListMainFav:Hide();
	EmoteListMainPageEins:Hide();
	EmoteListMainCustomSetzen:Hide();
end

function EmoteListFavm_OnClick()
	EmoteListMainPageZwei:Hide();
	EmoteListMainPageDrei:Hide();
	EmoteListMainWOTLK:Hide();
	EmoteListMainWOTLKZwei:Hide();
	EmoteListMainWOTLKDrei:Hide();
	EmoteListMainFav:Show();
	EmoteListMainPageEins:Hide();
	EmoteListMainCustomSetzen:Hide();
end

function EmoteListCustomm_OnClick()
	EmoteListMainPageZwei:Hide();
	EmoteListMainPageDrei:Hide();
	EmoteListMainWOTLK:Hide();
	EmoteListMainWOTLKZwei:Hide();
	EmoteListMainWOTLKDrei:Hide();
	EmoteListMainFav:Hide();
	EmoteListMainPageEins:Hide();
	EmoteListMainCustomSetzen:Show();
end

function EmoteList_ShowTooltipCustom()
	local id = this:GetID();
	local titel = EmoteListDB["CustomEmote"..id][1];
	local ohnetarget = EmoteListDB["CustomEmote"..id][2];
	local mittarget = EmoteListDB["CustomEmote"..id][3];
	local targetmannlich = EmoteListDB["CustomEmote"..id][4];
	local targetweiblich = EmoteListDB["CustomEmote"..id][5];
	
	if string.len(titel)>0 then
		EmoteList_ErstelleTooltip(titel, ohnetarget, mittarget, EMOTELIST_CUSTOM);
	else
	
	end	
end

function EmoteList_ShowTextCustom()
		local id = this:GetID();
		local buttontext = EmoteListDB["CustomEmote"..id][1];

	if string.len(buttontext)==0 then
		this:SetText(" ");
	else
		this:SetText(buttontext);	
	end
end

function EmoteListButtonDoEmoteCustom_OnClick()
	local id = this:GetID();
	local titel = EmoteListDB["CustomEmote"..id][1];
	local ohnetarget = EmoteListDB["CustomEmote"..id][2];
	local mittarget = EmoteListDB["CustomEmote"..id][3];
	local targetmannlich = EmoteListDB["CustomEmote"..id][4];
	local targetweiblich = EmoteListDB["CustomEmote"..id][5];
	local unitsex = UnitSex("target");
	local exists = UnitExists("target");
	
	if string.len(titel)>1 then
		if exists == 1 then
			if string.len(mittarget)>1 and string.len(targetmannlich)<1 and string.len(targetweiblich)<1 then
					SendChatMessage(mittarget, "EMOTE");
			end
			--mnnlich
			if string.len(targetmannlich)>1 then
				if unitsex == 2 then
					SendChatMessage(targetmannlich, "EMOTE");
				end
			end
			--weiblich
			if string.len(targetweiblich)>1 then
				if unitsex == 3 then
					SendChatMessage(targetweiblich, "EMOTE");
				end
			end
		else
			SendChatMessage(ohnetarget, "EMOTE");
		end
	end
end
