TITAN_EL_ID = "EmoteList";
TITAN_EL_FREQUENCY = 1;

EL_LOCALE = {
	menu = "Список эмоций",
	tooltip = "Список эмоций",
	button = "Список эмоций"
};

EL_TITAN_HINT = "|cff1eff00Левый-клик|r открывает окно эмоцый\n|cff1eff00Alt-клик|r открывает окно настроек";

function TitanPanelEmoteListButton_OnLoad(self)

	-- register plugin
	self.registry = { 
		id = TITAN_EL_ID,
		menuText = EL_LOCALE["menu"],
		buttonTextFunction = "TitanPanelEmoteListButton_GetButtonText",
		tooltipTitle = EL_LOCALE["tooltip"],
		tooltipTextFunction = "TitanPanelEmoteListButton_GetTooltipText",
		category = "Interface",
		frequency = TITAN_EL_FREQUENCY, 
		icon = "Interface\\Icons\\Ability_Ambush",
		iconWidth = 16,
		savedVariables = {
			ShowIcon = true,
			ShowLabelText = true,
			ShowColoredText = true,
		}
	};

end

function TitanPanelEmoteListButton_GetButtonText(id)
	local retstr = "";
	
	-- supports turning off labels
	if (TitanGetVar(TITAN_EL_ID, "ShowLabelText")) then	
		if (TitanGetVar(TITAN_EL_ID, "ShowColoredText")) then	
			retstr = TitanUtils_GetGreenText(EL_LOCALE["button"]);
		else
			retstr = TitanUtils_GetNormalText(EL_LOCALE["button"]);
		end
	end

	return retstr;
end

function TitanPanelEmoteListButton_OnClick(self, button)
	if (button == "LeftButton") then
		EmoteListButton_OnClick();
	end
end

function TitanPanelEmoteListButton_GetTooltipText()
	return EL_TITAN_HINT;
end

function TitanPanelRightClickMenu_PrepareEmoteListMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_EL_ID].menuText);
	
	TitanPanelRightClickMenu_AddToggleIcon(TITAN_EL_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_EL_ID);
	TitanPanelRightClickMenu_AddToggleColoredText(TITAN_EL_ID);

	TitanPanelRightClickMenu_AddSpacer();	
	
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_EL_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end
